/* Problem URL: https://codeforces.com/contest/961/problem/E */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vi fds(n);
    cin >> fds;

    int size = n;
    while (__builtin_popcount(size) != 1) {
        size++;
        fds.push_back(0);
    }

    vvl mergeseg(size * 2);

    function<void(int, int, int)> build = [&](int i, int l, int r) {
        if (l == r) {
            mergeseg[i] = {fds[i - size]};
            return;
        }

        int mid = (l + r) >> 1;

        build(i * 2, l, mid);
        build(i * 2 + 1, mid + 1, r);

        merge(all(mergeseg[i * 2]), all(mergeseg[i * 2 + 1]), back_inserter(mergeseg[i]));
    };

    build(1, 0, size - 1);

    function<ll(int, int, int, int, int, ll)> query = [&](int i, int l, int r, int tl, int tr, ll v) -> ll {
        if (l > tr || r < tl) {
            return 0LL;
        }

        if (l >= tl && r <= tr) {
            auto lower = lower_bound(all(mergeseg[i]), v);
            return mergeseg[i].end() - lower;
        }

        int mid = (l + r) >> 1;
        
        return query(i * 2, l, mid, tl, tr, v) + query(i * 2 + 1, mid + 1, r, tl, tr, v);
    };

    ll ans = 0;

    rep(i, n) {
        rmin(fds[i], n);
        if (fds[i] <= i + 1) {
            continue;
        }

        ans += query(1, 0, size - 1, i + 1, fds[i] - 1, i + 1);
    }
    cout << ans << '\n';
}
